// *********************************************************************
// Created with bc9 - BASIC To C/C++ Translator (V) 9.1.3.5 (2013/04/28)
//                 BCX (c) 1999 - 2009 by Kevin Diggins
// *********************************************************************
//              Translated for compiling with a C++ Compiler
//                           On MS Windows
// *********************************************************************
#ifndef UNICODE
#define UNICODE
#endif
#ifndef _UNICODE
#define _UNICODE
#endif
// Additional lines may be needed
#if defined( __cplusplus )
  #include <iostream>
  #include <fstream>
  #include <sstream>
  #include <iomanip>
  #include <locale>
  #include <algorithm>
  typedef std::string::value_type charT;
  typedef std::string stdstr;
  using namespace std;
#endif
#include <windows.h>    // Win32 Header File 
#include <windowsx.h>   // Win32 Header File 
#include <commctrl.h>   // Win32 Header File 
#include <commdlg.h>    // Win32 Header File 
#include <mmsystem.h>   // Win32 Header File 
#include <shellapi.h>   // Win32 Header File 
#include <shlobj.h>     // Win32 Header File 
#include <richedit.h>   // Win32 Header File 
#include <wchar.h>      // Win32 Header File 
#include <objbase.h>    // Win32 Header File 
#include <ocidl.h>      // Win32 Header File 
#include <winuser.h>    // Win32 Header File 
#include <olectl.h>     // Win32 Header File 
#include <oaidl.h>      // Win32 Header File 
#include <ole2.h>       // Win32 Header File 
#include <oleauto.h>    // Win32 Header File 
#include <winsock.h>    // Win32 Header File 
#include <process.h>    // dos
#include <conio.h>      // dos
#include <direct.h>     // dos
#include <io.h>         // dos
#include <ctype.h>      // dos/linux
#include <fcntl.h>      // dos/linux
#include <math.h>       // dos/linux
#include <stdio.h>      // dos/linux
#include <string.h>     // dos/linux
#include <stddef.h>     // dos/linux
#include <stdlib.h>     // dos/linux
#include <setjmp.h>     // dos/linux
#include <time.h>       // dos/linux
#include <stdarg.h>     // dos/linux
#include <sys/types.h>  
#include <sys/stat.h>   


// ***************************************************
// Compiler Defines
// ***************************************************

// C++
#if defined( __cplusplus )
  #define overloaded
  #define C_EXPORT EXTERN_C __declspec(dllexport)
  #define C_IMPORT EXTERN_C __declspec(dllimport)
#else
  #define C_EXPORT __declspec(dllexport)
  #define C_IMPORT __declspec(dllimport)
#endif

// Open Watcom defs
#if defined( __WATCOM_CPLUSPLUS__ ) || defined( __TINYC__ )
  #define atanl atan
  #define sinl  sin
  #define cosl  cos
  #define tanl  tan
  #define asinl asin
  #define acosl acos
  #define log10l log10
  #define logl   log
  #define _fcloseall fcloseall
#endif

// Borland C++ 5.5.1 defs - bcc32.exe
#if defined( __BCPLUSPLUS__ )
  // ===== Borland Libraries ==========
  #include <dos.h>
  #pragma comment(lib,"import32.lib")
  #pragma comment(lib,"cw32.lib")
  // ==================================
#endif
// MinGW

// Microsoft VC++
#ifndef DECLSPEC_UUID
  #if (_MSC_VER >= 1100) && defined ( __cplusplus )
    #define DECLSPEC_UUID(x)    __declspec(uuid(x))
  #else
    #define DECLSPEC_UUID(x)
  #endif
#endif

// *************************************************
// Tiny C support for LinkRes2Exe
#ifdef __TINYC__
  int dummy __attribute__ ((section(".rsrc")));
#endif
// *************************************************

// ***************************************************

#include "gdimage.h"
#pragma comment(lib,"GDImage64.lib")


// *************************************************
// Instruct Linker to Search Object/Import Libraries
// *************************************************
#if !defined( __LCC__ )
#pragma comment(lib,"kernel32.lib")
#pragma comment(lib,"user32.lib")
#pragma comment(lib,"gdi32.lib")
#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"advapi32.lib")
#pragma comment(lib,"winspool.lib")
#pragma comment(lib,"shell32.lib")
#pragma comment(lib,"ole32.lib")
#pragma comment(lib,"oleaut32.lib")
#pragma comment(lib,"uuid.lib")
#pragma comment(lib,"odbc32.lib")
#pragma comment(lib,"odbccp32.lib")
#pragma comment(lib,"winmm.lib")
#pragma comment(lib,"comdlg32.lib")
#pragma comment(lib,"imagehlp.lib")
#pragma comment(lib,"version.lib")
#else
#pragma lib <winspool.lib>
#pragma lib <shell32.lib>
#pragma lib <ole32.lib>
#pragma lib <oleaut32.lib>
#pragma lib <uuid.lib>
#pragma lib <odbc32.lib>
#pragma lib <odbccp32.lib>
#pragma lib <winmm.lib>
#pragma lib <imagehlp.lib>
#pragma lib <version.lib>
#endif
// *************************************************
// End of Object/Import Libraries To Search
// *************************************************

// *************************************************
//        User's GLOBAL ENUM blocks
// *************************************************

// *************************************************
//            System Defined Constants
// *************************************************

typedef const char* ccptr;
#define CCPTR const char*
#define cSizeOfDefaultString 2048 

// *************************************************
//            User Defined Constants
// *************************************************

#define ID_CTRL 101 
#define ID_START_SHOW 102 
#define ID_DECR 103 
#define ID_PAUSE 104 
#define ID_PLAY 105 
#define ID_INCR 106 
#define ID_STOP_SHOW 107 

// *************************************************
//               Standard Prototypes
// *************************************************

double  MAX (double,double);
// *************************************************
//          User Defined Types And Unions
// *************************************************


// *************************************************
//            User Global Variables
// *************************************************

static PCHAR   *g_argv;
static int     g_argc;
HINSTANCE g_hInst;
const wchar_t *BUTTON=L"BUTTON";


// *************************************************
//               Standard Macros
// *************************************************


// *************************************************
//               User Prototypes
// *************************************************

int     WINAPI WinMain (HINSTANCE,HINSTANCE,LPSTR,int);
HFONT   zDefaultFont (void);
void    zSetCTLFont (HWND,HFONT);
long    zRND (long,long);
LRESULT CALLBACK WndProc (HWND,UINT,WPARAM,LPARAM);

// *************************************************
//            User Global Initialized Arrays
// *************************************************



// *************************************************
//                 Runtime Functions
// *************************************************

double MAX (double a, double b)
{
  if(a>b)
  return a;
  return b;
}



// ************************************
//       User Subs and Functions
// ************************************

int WINAPI WinMain (HINSTANCE  hInst,HINSTANCE  hPrev,LPSTR  CmdLine,int CmdShow)
{
  MSG      msg={0};
  int      nRet={0};
  int      IsInitialized={0};
  WNDCLASSEX  wcx={0};
  HANDLE   hDll={0};
  WCHAR    szWindowClass[]=L"win64app";
  wstring  sCaption=L"SLIDE - GDImage ";
  if(sizeof(LONG_PTR)==8 )
    {
      sCaption+=L"64-bit";
    }
  else
    {
      sCaption+=L"32-bit";
    }
  wcx.cbSize= sizeof( WNDCLASSEX);
  IsInitialized= GetClassInfoEx( hInst, szWindowClass,  &wcx);
  if(IsInitialized==0 )
    {
      wcx.style= CS_HREDRAW| CS_VREDRAW;
      wcx.lpfnWndProc= WndProc;
      wcx.cbClsExtra= 0;
      wcx.cbWndExtra= 0;
      wcx.hInstance= hInst;
      wcx.hIcon= LoadIcon( hInst, MAKEINTRESOURCE( IDI_APPLICATION));
      wcx.hCursor= LoadCursor( NULL, IDC_ARROW);
      wcx.hbrBackground=( HBRUSH)( COLOR_WINDOW+ 1);
      wcx.lpszMenuName= NULL;
      wcx.lpszClassName= szWindowClass;
      wcx.hIconSm= wcx.hIcon;
      if(RegisterClassEx( &wcx))
        {
          IsInitialized=- 1;
        }
    }
  if(IsInitialized )
    {
      nRet= ZI_LoadDLL( L"");
      g_hInst= hInst;
      UINT     dwExStyle=WS_EX_APPWINDOW|WS_EX_WINDOWEDGE;
      UINT     dwStyle=WS_VISIBLE|WS_CLIPSIBLINGS|WS_CLIPCHILDREN|WS_CAPTION|WS_SYSMENU|WS_MAXIMIZEBOX|WS_MINIMIZEBOX;
      RECT     rc;
      SetRect( &rc,0,0,740,550);
      AdjustWindowRectEx( &rc,dwStyle,false,dwExStyle);
      int      x=MAX((GetSystemMetrics(SM_CXSCREEN)-rc.right-rc.left)/2,0);
      int      y=MAX((GetSystemMetrics(SM_CYSCREEN)-rc.bottom-rc.top)/2,0);
      HWND     hWnd=CreateWindowEx(dwExStyle,szWindowClass,(WCHAR*)sCaption.c_str(),dwStyle,x,y,rc.right-rc.left,rc.bottom-rc.top,NULL,NULL,hInst,NULL);
      if(hWnd )
        {
          ShowWindow(hWnd,CmdShow);
          UpdateWindow(hWnd);
          while((GetMessage( &msg,NULL,0,0)))
            {
              TranslateMessage( &msg);
              DispatchMessage( &msg);
            }

          nRet=( int) msg.wParam;
        }
    }
  return nRet;
}


HFONT zDefaultFont ()
{
  static HFONT    hDefault;
  if(hDefault==0 )
    {
      hDefault=( HFONT) GetStockObject( ANSI_VAR_FONT);
    }
  return hDefault;
}


void zSetCTLFont (HWND hCtrl,HFONT  hFont)
{
  SendMessage(hCtrl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
}


long zRND (long nMin,long nMax)
{
  return ((rand()*(nMax-nMin+1)/RAND_MAX))+nMin;
}


LRESULT CALLBACK WndProc (HWND hWnd,UINT Msg,WPARAM  wParam,LPARAM  lParam)
{
  int      wmId;
  int      wmEvent;
  long     K;
  long     imgW;
  long     imgH;
  long     UB;
  BYTE     PlayInLoopMode;
  PAINTSTRUCT  ps;
  RECT     rc;
  HDC      hdc;
  HWND     hCtrl;
  WCHAR    sFullName[MAX_PATH]={0};
  NMHDR*   nmh;
  ZSLIDESHOW*  PlayList;
  if(Msg==WM_CREATE )
    {
      CreateWindowEx(0,BUTTON,L"START",WS_CHILD|WS_VISIBLE|WS_TABSTOP,740-(10+150+6),10,152,22,hWnd,(HMENU)ID_START_SHOW,zInstance(),NULL);
      zSetCTLFont(GetDlgItem(hWnd,ID_START_SHOW),zDefaultFont());
      ZI_SetAnchorMode(GetDlgItem(hWnd,ID_START_SHOW),ANCHOR_RIGHT);
      CreateWindowEx(0,BUTTON,L"<<",WS_CHILD|WS_VISIBLE|WS_TABSTOP|WS_DISABLED,740-(10+150+6),10+(22+5)*1,24,22,hWnd,(HMENU)ID_DECR,zInstance(),NULL);
      zSetCTLFont(GetDlgItem(hWnd,ID_DECR),zDefaultFont());
      ZI_SetAnchorMode(GetDlgItem(hWnd,ID_DECR),ANCHOR_RIGHT);
      CreateWindowEx(0,BUTTON,L"PLAY",WS_CHILD|WS_TABSTOP|WS_DISABLED,740-(10+150+6)+28,10+(22+5)*1,96,22,hWnd,(HMENU)ID_PLAY,zInstance(),NULL);
      zSetCTLFont(GetDlgItem(hWnd,ID_PLAY),zDefaultFont());
      ZI_SetAnchorMode(GetDlgItem(hWnd,ID_PLAY),ANCHOR_RIGHT);
      CreateWindowEx(0,BUTTON,L"PAUSE",WS_CHILD|WS_VISIBLE|WS_TABSTOP|WS_DISABLED,740-(10+150+6)+28,10+(22+5)*1,96,22,hWnd,(HMENU)ID_PAUSE,zInstance(),NULL);
      zSetCTLFont(GetDlgItem(hWnd,ID_PAUSE),zDefaultFont());
      ZI_SetAnchorMode(GetDlgItem(hWnd,ID_PAUSE),ANCHOR_RIGHT);
      CreateWindowEx(0,BUTTON,L">>",WS_CHILD|WS_VISIBLE|WS_TABSTOP|WS_DISABLED,740-(10+150+6)+128,10+(22+5)*1,24,22,hWnd,(HMENU)ID_INCR,zInstance(),NULL);
      zSetCTLFont(GetDlgItem(hWnd,ID_INCR),zDefaultFont());
      ZI_SetAnchorMode(GetDlgItem(hWnd,ID_INCR),ANCHOR_RIGHT);
      CreateWindowEx(0,BUTTON,L"STOP",WS_CHILD|WS_VISIBLE|WS_TABSTOP,740-(10+150+6),10+(22+5)*2,152,22,hWnd,(HMENU)ID_STOP_SHOW,zInstance(),NULL);
      zSetCTLFont(GetDlgItem(hWnd,ID_STOP_SHOW),zDefaultFont());
      ZI_SetAnchorMode(GetDlgItem(hWnd,ID_STOP_SHOW),ANCHOR_RIGHT);
      ZI_CreateWindow(hWnd,10,10,740-(10+10+150+10+10),550-(10*2),(HMENU)ID_CTRL);
      wcscpy_s(sFullName,L"038.jpg");
      ZI_SetTiledBackground(GetDlgItem(hWnd,ID_CTRL),ZI_CreateBitmapFromFile(sFullName,imgW,imgH));
      ZI_SetAnchorMode(GetDlgItem(hWnd,ID_CTRL),ANCHOR_HEIGHT_WIDTH);
      goto L1001;
    }
  if(Msg==WM_NOTIFY )
    {
      nmh=( NMHDR*) lParam;
      if(nmh->idFrom==ID_CTRL )
        {
          if(nmh->code==NM_LASTSLIDE )
            {
              MessageBox(0,L"End of slide show notification.",L"Slide",MB_OK);
            }
        }
      goto L1001;
    }
  if(Msg==WM_COMMAND )
    {
      wmId= LOWORD( wParam);
      wmEvent= HIWORD( wParam);
      if(wmId==ID_START_SHOW )
        {
          if(IsWindowEnabled(GetDlgItem(hWnd,ID_DECR))==0 )
            {
              EnableWindow(GetDlgItem(hWnd,ID_DECR),true);
              EnableWindow(GetDlgItem(hWnd,ID_PLAY),true);
              EnableWindow(GetDlgItem(hWnd,ID_PAUSE),true);
              EnableWindow(GetDlgItem(hWnd,ID_INCR),true);
            }
          hCtrl= GetDlgItem( hWnd, ID_CTRL);
          UB= 3*( ZE_EFFECT_MAX+ 1);
          PlayList= new  ZSLIDESHOW[UB];
          memset(PlayList,0,sizeof(ZSLIDESHOW)*UB);
          K= 0;
            {
            long     Effect;
            for(Effect=ZE_EFFECT_MIN;Effect<=ZE_EFFECT_MAX;++Effect)
              {
                wcscpy_s(PlayList[K].fullname,L"avalon.jpg");
                zCheckName(PlayList[K].fullname);
                PlayList[K].delay= 2000;
                PlayList[K].grain= 1;
                PlayList[K].effect=( short) Effect;
                ++K;
                wcscpy_s(PlayList[K].fullname,L"genus.jpg");
                zCheckName(PlayList[K].fullname);
                PlayList[K].delay= 2000;
                PlayList[K].grain= 2;
                PlayList[K].effect=( short) Effect;
                wcscpy_s(PlayList[K].legend,L"GDImage Slide Show");
                wcscpy_s(PlayList[K].fontname,L"Times New Roman");
                PlayList[K].fontsize= 40;
                PlayList[K].fontcolor= ZD_ColorARGB( 32, RGB( 255, 255, 255));
                PlayList[K].shadow= 0;
                PlayList[K].location=( BYTE) zRND( ZE_TXT_TOP_LEFT, ZE_TXT_BOTTOM_RIGHT);
                ++K;
                wcscpy_s(PlayList[K].fullname,L"mask.png");
                zCheckName(PlayList[K].fullname);
                PlayList[K].delay= 2000;
                PlayList[K].grain= 1;
                PlayList[K].effect=( short) Effect;
                PlayList[K].backcolor= ZD_ColorARGB( 255, RGB( 128, 0, 0));
                ++K;
              }
              }

          PlayInLoopMode= 0;
          ZI_SlideAnimate(hCtrl, &PlayList[0],UB,PlayInLoopMode);
          delete[] PlayList;
          goto L1002;
        }
      if(wmId==ID_DECR )
        {
          ZI_SlidePlayDecrOrder();
          goto L1002;
        }
      if(wmId==ID_PAUSE )
        {
          if(IsWindowEnabled(GetDlgItem(hWnd,ID_DECR)))
            {
              EnableWindow(GetDlgItem(hWnd,ID_DECR),false);
              EnableWindow(GetDlgItem(hWnd,ID_INCR),false);
            }
          ShowWindow(GetDlgItem(hWnd,ID_PAUSE),SW_HIDE);
          ShowWindow(GetDlgItem(hWnd,ID_PLAY),SW_SHOW);
          ZI_SlidePause();
          goto L1002;
        }
      if(wmId==ID_PLAY )
        {
          if(IsWindowEnabled(GetDlgItem(hWnd,ID_DECR))==0 )
            {
              EnableWindow(GetDlgItem(hWnd,ID_DECR),true);
              EnableWindow(GetDlgItem(hWnd,ID_INCR),true);
            }
          ShowWindow(GetDlgItem(hWnd,ID_PLAY),SW_HIDE);
          ShowWindow(GetDlgItem(hWnd,ID_PAUSE),SW_SHOW);
          ZI_SlidePlay();
          goto L1002;
        }
      if(wmId==ID_INCR )
        {
          ZI_SlidePlayIncrOrder();
          goto L1002;
        }
      if(wmId==ID_STOP_SHOW )
        {
          ZI_SlideStop();
          if(IsWindowEnabled(GetDlgItem(hWnd,ID_DECR)))
            {
              EnableWindow(GetDlgItem(hWnd,ID_DECR),false);
              EnableWindow(GetDlgItem(hWnd,ID_PLAY),false);
              EnableWindow(GetDlgItem(hWnd,ID_PAUSE),false);
              EnableWindow(GetDlgItem(hWnd,ID_INCR),false);
            }
        }
L1002:; // SelectState[PusherSelectState].CaseFlag 6
      return 0;
    }
  if(Msg==WM_PAINT )
    {
      hdc= BeginPaint( hWnd,  &ps);
      GetClientRect(hWnd, &rc);
      ZI_GradientPaintDC(hdc,0,0,rc.right,rc.bottom,RGB(228,227,227),RGB(168,167,191));
      EndPaint(hWnd, &ps);
      return 0;
    }
  if(Msg==WM_DESTROY )
    {
      PostQuitMessage(0);
      return 0;
    }
L1001:; // SelectState[PusherSelectState].CaseFlag 3
  return DefWindowProc(hWnd, Msg, wParam, lParam); // CallBackFlag
}



