'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Clone of Patrice's Slide  GDImage64 demo
'Translated as a unicode app -u
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$CPPHDR
$ONEXIT "VC.BAT $FILE$ -m64 gui Release"
$NOMAIN
$HEADER
	#include "gdimage.h"
	#pragma comment(lib,"GDImage64.lib")
$HEADER
'==============================================================================
CONST ID_CTRL = 101
CONST ID_START_SHOW = 102
CONST ID_DECR = 103
CONST ID_PAUSE = 104
CONST ID_PLAY =  105
CONST ID_INCR = 106
CONST ID_STOP_SHOW = 107

Raw As const wchar_t Ptr BUTTON = L"BUTTON"
Raw As HINSTANCE g_hInst
'==============================================================================
Function WinMain()
	
	Local As MSG msg
	Local As Integer nRet,IsInitialized
	Local As WNDCLASSEX wcx
	Local As HANDLE hDll
	
	Raw As WCHAR szWindowClass[] = L"win64app"
	Raw As wstring sCaption = L"SLIDE - GDImage "
	If sizeof(LONG_PTR) = 8 Then
		sCaption+= L"64-bit"
	Else
		sCaption += L"32-bit"
	End If 
	' Register the main window class
    wcx.cbSize = sizeof(WNDCLASSEX)
    IsInitialized = GetClassInfoEx(hInst, szWindowClass, &wcx)
    
	If IsInitialized = 0 Then
        wcx.style         = CS_HREDRAW | CS_VREDRAW
        wcx.lpfnWndProc   = WndProc
        wcx.cbClsExtra    = 0
        wcx.cbWndExtra    = 0
        wcx.hInstance     = hInst
        wcx.hIcon         = LoadIcon(hInst, MAKEINTRESOURCE(IDI_APPLICATION))
        wcx.hCursor       = LoadCursor(NULL, IDC_ARROW)
        wcx.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1)
        wcx.lpszMenuName  = NULL
        wcx.lpszClassName = szWindowClass
        wcx.hIconSm       = wcx.hIcon
        If RegisterClassEx(&wcx) Then
        	IsInitialized = -1	
        End If
	End If
	 
	 If IsInitialized Then
	 	nRet = ZI_LoadDLL (L"")
	 	g_hInst = hInst
	 	Raw As UINT dwExStyle = WS_EX_APPWINDOW | WS_EX_WINDOWEDGE
	 	Raw As UINT dwStyle = WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_CAPTION | WS_SYSMENU | WS_MAXIMIZEBOX | WS_MINIMIZEBOX
	 	Raw As RECT rc
	 	SetRect(&rc, 0, 0, 740, 550)
	 	AdjustWindowRectEx(&rc, dwStyle, FALSE, dwExStyle)    ' Adjust Window To True Requested Size
	 	Raw As int x = max((GetSystemMetrics(SM_CXSCREEN) - rc.right - rc.left) / 2, 0)
	 	Raw As int y = max((GetSystemMetrics(SM_CYSCREEN) - rc.bottom - rc.top) / 2, 0)
	 	Raw As HWND hWnd = 	CreateWindowEx( _
                            dwExStyle, _ 						'Optional window styles.
                    		szWindowClass, _                 	' Window class
                    		(WCHAR*) sCaption.c_str(), _     	' Window text
                    		dwStyle, _                       	' Window style
                    		x, y, rc.right - rc.left, rc.bottom - rc.top, _
                    		NULL, _                           	' Parent window    
                    		NULL, _                          	' Menu
                    		hInst, _                     		' Instance handle
                    		NULL _                           	' Additional application data
                    		)
		If hWnd Then
			ShowWindow(hWnd, CmdShow)
			UpdateWindow(hWnd)
	
			While (GetMessage(&msg, NULL, 0, 0)) 
			   TranslateMessage(&msg)
			   DispatchMessage(&msg)
			Wend
			nRet = (int) msg.wParam
			
		End If
	 End If

	 Function = nRet
End Function
'==============================================================================
Function zDefaultFont() As HFONT
	static hDefault As HFONT
	If hDefault = 0 Then
		hDefault = (HFONT) GetStockObject(ANSI_VAR_FONT)
	End If
	Function = hDefault
End Function
'==============================================================================
Sub zSetCTLFont(hCtrl As HWND , hFont As HFONT)
	SendMessage(hCtrl, WM_SETFONT, (WPARAM) hFont, 0)
End Sub
'============================================================================== 
'RND name changed to zRND to avoid bc9 name conflict
Function zRND (nMin As long, nMax As Long) As long
	Function = ((rand() * (nMax - nMin + 1) / RAND_MAX)) + nMin
End Function
'==============================================================================

CALLBACk Function WndProc()
	Raw As Integer wmId, wmEvent
	Raw As long K, imgW, imgH, UB
	Raw As BYTE PlayInLoopMode
	Raw As PAINTSTRUCT ps
	Raw As RECT rc
	Raw As HDC hdc
	Raw As HWND hCtrl
	Raw As WCHAR sFullName[MAX_PATH]={0}
	Raw As NMHDR Ptr nmh
	Raw As ZSLIDESHOW Ptr PlayList
	
	Select Case CBMSG
		Case WM_CREATE
        	' Create button "START"
			CreateWindowEx(0, BUTTON, L"START", WS_CHILD | WS_VISIBLE | WS_TABSTOP, _ 
                        740 - (10 + 150 + 6), 10, 152, 22, hWnd, (HMENU) ID_START_SHOW, zInstance(), NULL)
			zSetCTLFont(GetDlgItem(hWnd, ID_START_SHOW), zDefaultFont())
			ZI_SetAnchorMode(GetDlgItem(hWnd, ID_START_SHOW), ANCHOR_RIGHT)

        	' Create button "DECR"
			CreateWindowEx(0, BUTTON, L"<<", WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_DISABLED, _ 
			           740 - (10 + 150 + 6), 10 + (22 + 5) * 1, 24, 22, hWnd, (HMENU) ID_DECR, zInstance(), NULL)
			zSetCTLFont(GetDlgItem(hWnd, ID_DECR), zDefaultFont())
			ZI_SetAnchorMode(GetDlgItem(hWnd, ID_DECR), ANCHOR_RIGHT)
			
			' Create button "PLAY"
			CreateWindowEx(0, BUTTON, L"PLAY", WS_CHILD | WS_TABSTOP | WS_DISABLED, _ 
			            740 - (10 + 150 + 6) + 28, 10 + (22 + 5) * 1, 96, 22, hWnd, (HMENU) ID_PLAY, zInstance(), NULL)
			zSetCTLFont(GetDlgItem(hWnd, ID_PLAY), zDefaultFont())
			ZI_SetAnchorMode(GetDlgItem(hWnd, ID_PLAY), ANCHOR_RIGHT)
			
			' Create button "PAUSE"
			CreateWindowEx(0, BUTTON, L"PAUSE", WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_DISABLED, _ 
			            740 - (10 + 150 + 6) + 28, 10 + (22 + 5) * 1, 96, 22, hWnd, (HMENU)ID_PAUSE, zInstance(), NULL)
			zSetCTLFont(GetDlgItem(hWnd, ID_PAUSE), zDefaultFont())
			ZI_SetAnchorMode(GetDlgItem(hWnd, ID_PAUSE), ANCHOR_RIGHT)
			
			' Create button "INCR"
			CreateWindowEx(0, BUTTON, L">>", WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_DISABLED, _ 
			            740 - (10 + 150 + 6) + 128, 10 + (22 + 5) * 1, 24, 22, hWnd, (HMENU) ID_INCR, zInstance(), NULL)
			zSetCTLFont(GetDlgItem(hWnd, ID_INCR), zDefaultFont())
			ZI_SetAnchorMode(GetDlgItem(hWnd, ID_INCR), ANCHOR_RIGHT)
			
			' Create button "STOP"
			CreateWindowEx(0, BUTTON, L"STOP", WS_CHILD | WS_VISIBLE | WS_TABSTOP, _ 
			              740 - (10 + 150 + 6), 10 + (22 + 5) * 2, 152, 22, hWnd, (HMENU) ID_STOP_SHOW, zInstance(), NULL)
			zSetCTLFont(GetDlgItem(hWnd, ID_STOP_SHOW), zDefaultFont())
			ZI_SetAnchorMode(GetDlgItem(hWnd, ID_STOP_SHOW), ANCHOR_RIGHT)
			
			' ******************************************************************************
			' Helper function to create A GDImage control (with automatic scrollbar support)
			' ------------------------------------------------------------------------------
			ZI_CreateWindow(hWnd, 10, 10, 740 - (10 + 10 + 150 + 10 + 10), 550 - (10 * 2), (HMENU) ID_CTRL)
			wcscpy_s(sFullName, L"038.jpg")
			ZI_SetTiledBackground(GetDlgItem(hWnd, ID_CTRL), ZI_CreateBitmapFromFile(sFullName, imgW, imgH))
			ZI_SetAnchorMode(GetDlgItem(hWnd, ID_CTRL), ANCHOR_HEIGHT_WIDTH)
			
		Case WM_NOTIFY
			nmh = (NMHDR*) lParam
			If nmh->idFrom = ID_CTRL Then
				If nmh->code = NM_LASTSLIDE Then
					MessageBox(0, L"End of slide show notification.", L"Slide", MB_OK)
				End If
			End If
		Case WM_COMMAND
			wmId    = LOWORD(wParam) 'CBCTL
			wmEvent = HIWORD(wParam) 'CBCTLMSG
        '	Process menu command
			Select Case wmId
				Case ID_START_SHOW
					If IsWindowEnabled(GetDlgItem(hWnd, ID_DECR)) = 0 Then
						EnableWindow(GetDlgItem(hWnd, ID_DECR), TRUE)
						EnableWindow(GetDlgItem(hWnd, ID_PLAY), TRUE)
						EnableWindow(GetDlgItem(hWnd, ID_PAUSE), TRUE)
						EnableWindow(GetDlgItem(hWnd, ID_INCR), TRUE)
					End If
					hCtrl = GetDlgItem(hWnd, ID_CTRL)
					UB = 3 * (ZE_EFFECT_MAX + 1)
					PlayList = new ZSLIDESHOW[UB]
					memset(PlayList, 0, sizeof(ZSLIDESHOW) * UB) ' Fill up the whole new array with nulls (to mimic what PB's does)
					K = 0
					xFor long Effect = ZE_EFFECT_MIN WHILE Effect <= ZE_EFFECT_MAX BY ++Effect
					
						wcscpy_s(PlayList[K].fullname, L"avalon.jpg")
						zCheckName(PlayList[K].fullname)
						PlayList[K].delay     = 2000
						PlayList[K].grain     = 1           ' <-- Use a larger grain on slow computer.
						PlayList[K].effect    = (short) Effect
						
						++K
						wcscpy_s(PlayList[K].fullname, L"genus.jpg")
						zCheckName(PlayList[K].fullname)
						PlayList[K].delay     = 2000
						PlayList[K].grain     = 2     ' <-- Use a larger grain on slow computer.
						PlayList[K].effect    = (short) Effect
						wcscpy_s(PlayList[K].legend, L"GDImage Slide Show")
						wcscpy_s(PlayList[K].fontname, L"Times New Roman")
						PlayList[K].fontsize  = 40
						PlayList[K].fontcolor = ZD_ColorARGB(32, RGB(255,255,255))
						PlayList[K].shadow    = 0          ' <-- Font shadow offset
						PlayList[K].location  = (BYTE) zRND(ZE_TXT_TOP_LEFT, ZE_TXT_BOTTOM_RIGHT)

						++K
						wcscpy_s(PlayList[K].fullname, L"mask.png")
						zCheckName(PlayList[K].fullname)
						PlayList[K].delay     = 2000
						PlayList[K].grain     = 1           ' <-- Use a larger grain on slow computer.
						PlayList[K].effect    = (short) Effect
						PlayList[K].backcolor = ZD_ColorARGB(255, RGB(128,0,0)) ' note: slide show use only 24-bit
						
						++K
						
					xNext
					
					PlayInLoopMode = 0
					ZI_SlideAnimate(hCtrl, &PlayList[0], UB, PlayInLoopMode)
					delete [] PlayList
					
				Case ID_DECR
              		ZI_SlidePlayDecrOrder()
              		
				Case ID_PAUSE
					If IsWindowEnabled(GetDlgItem(hWnd, ID_DECR)) Then
						EnableWindow(GetDlgItem(hWnd, ID_DECR), FALSE)
						EnableWindow(GetDlgItem(hWnd, ID_INCR), FALSE)
					End If
					ShowWindow(GetDlgItem(hWnd, ID_PAUSE), SW_HIDE)
					ShowWindow(GetDlgItem(hWnd, ID_PLAY), SW_SHOW)
					ZI_SlidePause()
					
				Case ID_PLAY
					If IsWindowEnabled(GetDlgItem(hWnd, ID_DECR)) = 0 Then 
						EnableWindow(GetDlgItem(hWnd, ID_DECR), TRUE)
						EnableWindow(GetDlgItem(hWnd, ID_INCR), TRUE)
					End If
					ShowWindow(GetDlgItem(hWnd, ID_PLAY), SW_HIDE)
					ShowWindow(GetDlgItem(hWnd, ID_PAUSE), SW_SHOW)
					ZI_SlidePlay()
					
				Case ID_INCR
					ZI_SlidePlayIncrOrder()
				
				Case ID_STOP_SHOW
					ZI_SlideStop()
					If IsWindowEnabled(GetDlgItem(hWnd, ID_DECR)) Then 
						EnableWindow(GetDlgItem(hWnd, ID_DECR), FALSE)
						EnableWindow(GetDlgItem(hWnd, ID_PLAY), FALSE)
						EnableWindow(GetDlgItem(hWnd, ID_PAUSE), FALSE)
						EnableWindow(GetDlgItem(hWnd, ID_INCR), FALSE)
					End If	
			End Select
			Function = 0
		Case WM_PAINT
			hdc = BeginPaint(hWnd, &ps)
			' TODO: process here the WM_PAINT message...
			GetClientRect (hWnd, &rc)
			ZI_GradientPaintDC(hdc, 0, 0, rc.right, rc.bottom, RGB(228,227,227), RGB(168,167,191))
			EndPaint(hWnd, &ps)
			Function = 0
				
		Case WM_DESTROY
			PostQuitMessage(0)
			Function = 0
			
	End Select
End Function
 